# CHEKMO II: Chess Playing Program

Originally distributed as DECUS 8-822

Upstream source:  Vince Slyngstad's so-much-stuff repository offers the [archival
DECUS 8-882][vince] source and a PDF scan of the documentation (provided here
as decus-8-882.pdf). 

However, a slightly modified source can be found in a [DECtape image on
Dave Gesswein's pdp8online.com][dgw-src]. It has a small patch and enables
the OS8 config by default.  That is the source of CHEKMO.PA provided here.

There is also a cool writeup with links to other interesting content at
[chesprogramming.org/CHEKMO-II][chessprog]

## Original Decus Writeup:

**Author:** John E. Comeau
Digital Equipment Corporation Maynard, MA

**Operating System:** Paper Tape

**Source Language:** PAL-8

**Memory Required:** 4K

**Other Software Required:** Requires OS/8 for assembly.

**Abstract:** CHEKMO II is a chess playing program which will run on
any PDP-8 family computer. The program will play either the white
pieces or the black pieces, and will play and accept all classes of legal
moves, including castling both short and long, en passant pawn captures,
and pawn promoting moves to any legal promotion piece. The program
prints out its moves m Algebraic Notation, and accepts moves using
Algebraic Notation.

Included in the command structure of the program are commands
which allow you to input board positions using Forsyth Notation, and get
a printout of the board at your terminal.

**Media Price Code:** A2, F6, H32, K27
**Format:** OS/8
**Catalog:** August 1978

[vince]: http://svn.so-much-stuff.com/svn/trunk/pdp8/src/decus/8-822/
[dgw-src]: http://www.pdp8.net/pdp8cgi/os8_html?act=dir;fn=images/misc_dectapes/chekmo_misc.tu56;sort=name
[chessprog]: https://www.chessprogramming.org/CHEKMO-II
